************************************************************************
PATCH.udp_usrreq.c  
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************

*** /nfs/atom/atomic/4.1.3-sys/netinet/udp_usrreq.c	Thu Apr 17 18:39:16 1997
--- udp_usrreq.c	Sat Mar  1 16:00:42 1997
***************
*** 96,101 ****
--- 96,103 ----
  	/*
  	 * Checksum extended UDP header and data.
  	 */
+ 	
+ 	
  	if (udp_cksum && ui->ui_sum) {
  		ui->ui_next = ui->ui_prev = 0;
  		ui->ui_x1 = 0;
***************
*** 125,132 ****
  		 * inadequacy of the UDP socket interface, but for backwards
  		 * compatibility we avoid the problem here rather than
  		 * fixing the interface.  Maybe 4.4BSD will remedy this?)
- 		 * Note that sockets which have not set any multicast options
- 		 * will not receive any multicast datagrams.
  		 */
  
  		/*
--- 127,132 ----
***************
*** 156,164 ****
  				    inp->inp_fport != ui->ui_sport)
  					continue;
  			}
- 			if (IN_MULTICAST(ntohl(ui->ui_dst.s_addr)) &&
- 			    (inp->inp_moptions == NULL))
- 			    continue;
  
  			if (last != NULL) {
  				struct mbuf *n;
--- 156,161 ----
***************
*** 199,205 ****
  		sorwakeup(last);
  		return;
  	}
! #endif /* MULTICAST */
  	/*
  	 * Locate pcb for datagram. 
  	 * Check our local cache first.
--- 196,202 ----
  		sorwakeup(last);
  		return;
  	}
! #endif MULTICAST
  	/*
  	 * Locate pcb for datagram. 
  	 * Check our local cache first.
***************
*** 224,230 ****
  		/* don't send ICMP response for broadcast packet */
  		if (in_broadcast(ui->ui_dst))
  			goto bad;
! #endif /* MULTICAST */
  		*(struct ip *)ui = ip;
  		icmp_error((struct ip *)ui, ICMP_UNREACH, ICMP_UNREACH_PORT,
  		    ifp);
--- 221,227 ----
  		/* don't send ICMP response for broadcast packet */
  		if (in_broadcast(ui->ui_dst))
  			goto bad;
! #endif MULTICAST
  		*(struct ip *)ui = ip;
  		icmp_error((struct ip *)ui, ICMP_UNREACH, ICMP_UNREACH_PORT,
  		    ifp);
***************
*** 348,360 ****
  	((struct ip *)ui)->ip_len = sizeof (struct udpiphdr) + len;
  	((struct ip *)ui)->ip_ttl = udp_ttl;
  #ifdef MULTICAST
  	return (ip_output(m, inp->inp_options, &inp->inp_route,
  	    inp->inp_socket->so_options & (SO_DONTROUTE | SO_BROADCAST)
  	    | IP_MULTICASTOPTS, inp->inp_moptions));
  #else
  	return (ip_output(m, inp->inp_options, &inp->inp_route,
  	    inp->inp_socket->so_options & (SO_DONTROUTE | SO_BROADCAST)));
! #endif /* MULTICAST */
  }
  
  
--- 345,375 ----
  	((struct ip *)ui)->ip_len = sizeof (struct udpiphdr) + len;
  	((struct ip *)ui)->ip_ttl = udp_ttl;
  #ifdef MULTICAST
+ #ifdef AH
+          return (ip_output(m, inp->inp_options, &inp->inp_route,
+             inp->inp_socket->so_options & (SO_DONTROUTE  | SO_BROADCAST | SO_AUTHOPTS) | IP_MULTICASTOPTS, inp->inp_moptions));
+         
+ #else 
+ 
+ 
  	return (ip_output(m, inp->inp_options, &inp->inp_route,
  	    inp->inp_socket->so_options & (SO_DONTROUTE | SO_BROADCAST)
  	    | IP_MULTICASTOPTS, inp->inp_moptions));
+ #endif AH
+ 
  #else
+ #ifdef AH	
  	return (ip_output(m, inp->inp_options, &inp->inp_route,
+ 	    inp->inp_socket->so_options & (SO_DONTROUTE | SO_BROADCAST | SO_AUTHOPTS)));
+ 
+ 
+ 
+ #else
+ 	return (ip_output(m, inp->inp_options, &inp->inp_route,
  	    inp->inp_socket->so_options & (SO_DONTROUTE | SO_BROADCAST)));
! 
! #endif
! #endif MULTICAST
  }
  
  
