/* md5.h: "RSA Data Security, Inc. MD5 Message-Digest Algorithm"
        (header file for MD5C.C)

Portions of this software are Copyright 1995 by Randall Atkinson and Dan
McDonald, All Rights Reserved. All Rights under this copyright are assigned
to the U.S. Naval Research Laboratory (NRL). The NRL Coyright Notice and
License Agreement applies to this software.

        History:

        Modified at NRL for OPIE 2.0.
        Originally from RSADSI reference code.
*/
/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
rights reserved.

License to copy and use this software is granted provided that it
is identified as the "RSA Data Security, Inc. MD5 Message-Digest
Algorithm" in all material mentioning or referencing this software
or this function.

License is also granted to make and use derivative works provided
that such works are identified as "derived from the RSA Data
Security, Inc. MD5 Message-Digest Algorithm" in all material
mentioning or referencing the derived work.

RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.

These notices must be retained in any copies of any part of this
documentation and/or software.
 */

/************************************************************************
nbomd5.h - Original md5.h modified for 'Network Byte Order' Rog algorithm
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************/

/* MD5 context. */
#ifndef _nbomd5_h
#define _nbomd5_h

#ifndef AH_TYPES
#define AH_TYPES
typedef u_char u_int8;
typedef u_short u_int16;
typedef u_int  u_int32;
#endif AH_TYPES

#include "md5.h"

/*struct MD5_CTX {
  u_int32 state[4];	*//* state (ABCD) */
/*  u_int32 count[2];	*//* number of bits, modulo 2^64 (lsb first) */
/*  u_int8  buffer[64];*/	/* input buffer */
/*};*/
/* changes */
void NBOMD5Init();
void NBOMD5Update();
void NBOMD5Final();

/* copied from mddriver.c 
   Swap or not depending on the endianness of the machine
*/
/* CHECK - just swapped those for MD5opt*/
#if (defined(i386) | defined(__alpha))
static int nborog_reorder = 1; /* don't reorder on little-endian */
#else
static int nborog_reorder = 0; /* reorder on big-endian */
#endif



#endif _nbomd5_h





