************************************************************************
nbomd5_opt.h - contains variable definitions for 'network byte order'
MD5-Optimised algorithm.
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************/
#ifndef _nbomd5_opt_h
#define _nbomd5_opt_h

#include <sys/types.h>

/*
This includes the structure definitions in md5.h
(no harm if included twice)
*/

#include <netinet/md5.h>
#include "sec_debug.h"


/*change -Include all stuff from global.h */
#include "global.h"



void NBOMD5optInit();
void NBOMD5optUpdate();
void NBOMD5optFinal();

/* copied from mddriver.c 
   Swap or not depending on the endianness of the machine
*/
/* CHECK - just swapped those for MD5opt*/
#if (defined(i386) | defined(__alpha))
static int nbo_reorder = 1; /* don't reorder on little-endian */
#else
static int nbo_reorder = 0; /* reorder on big-endian */
#endif

#endif _nbomd5_opt_h







