/************************************************************************
sec_debug.h - It contains functions and variables that help debugging.
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************/

#ifndef _netinet_sec_debug_h
#define _netinet_sec_debug_h


/* AH_PRINTFS should not be defined in case debugging (printf's) are not 
   required. */
 
/*#define AH_DEBUG */   /* Remove comments to print for debugging */
/* For the md5_opt debugging*/
/*#define BUG*/

#include <syslog.h>
/* Presently using printing to screen for debugging */
#include "ahstat.h"

#ifdef AH_DEBUG
#define DAPRINTF(x)  log(LOG_DEBUG, x)
#define DLOG(x) log x

/* The  following for the cc compiler */


/* While using DAP, make sure there is no space between the comma 
   and the argument y */ 

#define DAP(x,y) log(LOG_DEBUG ,"x is %y\n", x)


#define DADO(x) x
#else
#define DAPRINTF(x)
#define DLOG(x)
#define DAP(x,y)	
#define DADO(x)
#endif AH_DEBUG


/* For a particular bug*/
#ifdef BUG
#define BUGPRINTF(x)  log(LOG_EMERG, x)
#define BUGLOG(x) log x
#else
#define BUGPRINTF(x)
#define BUGLOG(x)
#endif

/*#define BUGY*/
#ifdef BUGY
#define BUGYPRINTF(x)  log(LOG_DEBUG, x)
#define BUGYLOG(x) log x
#else
#define BUGYPRINTF(x)
#define BUGYLOG(x)
#endif


#endif _netinet_sec_debug_h


