************************************************************************
PATCH.uipc_mbuf.c
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************

*** /nfs/atom/atomic/4.1.3-sys/os/uipc_mbuf.c	Wed Jun 16 12:14:09 1993
--- uipc_mbuf.c	Tue Jan 30 17:22:02 1996
***************
*** 9,15 ****
   * software without specific prior written permission. This software
   * is provided ``as is'' without express or implied warranty.
   *
!  *	@(#)uipc_mbuf.c 1.1 92/07/30 SMI; from UCB 7.4.1.2 2/8/88
   */
  
  #include <sys/param.h>
--- 9,15 ----
   * software without specific prior written permission. This software
   * is provided ``as is'' without express or implied warranty.
   *
!  *	@(#)uipc_mbuf.c 2.45 92/03/12 SMI; from UCB 7.4.1.2 2/8/88
   */
  
  #include <sys/param.h>
***************
*** 38,43 ****
--- 38,48 ----
  extern	int cache;
  #endif defined(sun4m) && defined(IOMMU)
  
+ #ifdef SOMAP
+ #include <sundev/somap.h>
+ extern int	somap_mfree();
+ #endif
+ 
  /*
   * The way the code stands, MCLBYTES must be a power of 2
   * and type MCL_LOANED cluster mbufs, if swappable, must
***************
*** 914,919 ****
--- 919,941 ----
  		splx(s);
  		break;
  	case MCL_LOANED:
+ #ifdef SOMAP
+ 		if (m->m_clfun == somap_mfree) {
+ 			register struct somap_free_mbuf_info 
+ 				*fi = (struct somap_free_mbuf_info *)m->m_clarg;
+ 			int s = splimp();
+ 
+ 			p = mtod(m, struct mbuf *);
+ 			n->m_off = (int) p - (int)n;
+ 			n->m_cltype = MCL_LOANED;
+ 			n->m_clfun = somap_mfree;
+ 			n->m_clarg = (int)fi;
+ 			n->m_clswp = NULL;
+ 			fi->refcnt++;
+ 			splx(s);
+ 			break;
+ 		}
+ #endif
  		copybuf = new_kmem_alloc(
  			(u_int)(n->m_len + sizeof (int)), KMEM_NOSLEEP);
  		if (!copybuf)
