************************************************************************
PATCH.uipc_socket.c - contains socket values for authentication algorithms
and for generating statistics.
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************

*** /nfs/atom/atomic/4.1.3-sys/os/uipc_socket.c	Wed Jun 16 12:14:09 1993
--- uipc_socket.c	Thu Aug 14 12:35:19 1997
***************
*** 1,3 ****
--- 1,5 ----
+ /* This file from os/ */
+ 
  /*
   * Copyright (c) 1982, 1986 Regents of the University of California.
   * All rights reserved.
***************
*** 45,50 ****
--- 47,53 ----
   */
  /*ARGSUSED*/
  socreate(dom, aso, type, proto)
+ 	int dom;
  	struct socket **aso;
  	register int type;
  	int proto;
***************
*** 811,821 ****
--- 814,863 ----
  				so->so_options &= ~SO_LINGER;
  			break;
  
+ 
+ #ifdef AH
+                 /* The following code prevents a user program from 
+                 modifying the flag for an authentication option when
+                 flag for any of the OTHER authentication options is SET.
+                 (An error is returned) */
+                 /* more compact code than the previous version*/
+ 
+ 		
+ 		case SO_SENDAUTH:
+                 case SO_SENDCKSUM:
+ 		case SO_SENDMD5:
+       	        case SO_SENDMD5OPT:
+ 		case SO_SENDAHA:
+ 		case SO_SENDNBOMD5OPT:
+ 		case SO_SENDNULLCKSUM:
+                 case SO_SENDROG:
+ 		case SO_SENDNBOROG:
+ 		  /* Put before all the other options as 
+                       if one of the other ones was
+                       set after one of the authentication
+                       options, it would return an error
+                    */                   
+ 
+ 		   if ( (SO_AUTHOPTS & ~optname) & so->so_options )
+ 		   {
+ 		     error = EINVAL; 
+ 		     /*CHANGE: the error value */
+ 		     goto bad;
+ 		   }
+ 			
+ 		/* fall through ....... */
+                 /* Pass nothing => option set
+                    Pass 0     => option flag disabled
+                    Pass any other integer => option set
+                 */
+ #endif AH
+ 
  		case SO_DEBUG:
  		case SO_KEEPALIVE:
  		case SO_DONTROUTE:
  		case SO_USELOOPBACK:
  		case SO_REUSEADDR:
+          
  #ifndef notyet
  			/*
  			 * 4.2 compatibility code.
***************
*** 924,929 ****
--- 966,984 ----
  		case SO_KEEPALIVE:
  		case SO_REUSEADDR:
  		case SO_BROADCAST:
+ #ifdef AH
+ 		case SO_SENDAUTH:
+                 case SO_SENDCKSUM:
+ 		case SO_SENDMD5:
+                 case SO_SENDMD5OPT:
+                 case SO_SENDAHA:
+ 		case SO_SENDNBOMD5OPT:
+ 		case SO_SENDNULLCKSUM:
+                 case SO_SENDROG:
+ 		case SO_SENDNBOROG:
+ 		
+ #endif AH     /* AH */ 
+                 
  		case SO_OOBINLINE:
  			*mtod(m, int *) = so->so_options & optname;
  			break;
***************
*** 985,987 ****
--- 1040,1069 ----
  		so->so_rcv.sb_flags &= ~SB_COLL;
  	}
  }
+ 
+ /* -----------------------------------------------------------------*/
+ #include <netinet/ahstat.h>
+ getahstat(){
+ 
+   register struct a {
+     struct ahstat *ahs;
+   } *uap = (struct a *) u.u_ap;
+   
+   u.u_error = copyout ( (caddr_t)&ahstat, (caddr_t)uap->ahs, sizeof(struct ahstat));
+ }
+ 
+ setahstat() {
+   register struct a {
+     struct ahstat *ahs;
+   }* uap = (struct a *) u.u_ap;
+ 
+   u.u_error = copyin ((caddr_t) uap->ahs, (caddr_t) &ahstat, sizeof (struct ahstat));
+ 
+ }
+ 
+ 
+   
+   
+ 
+ 
+ 
