************************************************************************
PATCH.socket.h - contains definitions of sockets used for auth algorithms
 
Copyright (c) 1997 University of Southern California.
All rights reserved.                                            
                                                                
Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation, advertising
materials, and other materials related to such distribution and use
acknowledge that the software was developed by the University of
Southern California, Information Sciences Institute.  The name of the
University may not be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

************************************************************************

*** /nfs/atom/atomic/4.1.3-sys/sys/socket.h	Wed Jun 16 12:16:53 1993
--- socket.h	Tue Aug 19 12:16:51 1997
***************
*** 1,3 ****
--- 1,5 ----
+ /* This is from /sys */
+ 
  /*	@(#)socket.h 1.1 92/07/30 SMI; from UCB 7.1 6/4/86	*/
  
  /*
***************
*** 34,43 ****
--- 36,70 ----
  #define	SO_USELOOPBACK	0x0040		/* bypass hardware when possible */
  #define	SO_LINGER	0x0080		/* linger on close if data present */
  #define	SO_OOBINLINE	0x0100		/* leave received OOB data in line */
+ #ifdef AH
+ 
+ #define SO_SENDAUTH     0X0200          /* Send using Authentication */
+ #define SO_SENDCKSUM    0X0400          /*Send cksum Authenticated packets*/
+ #define SO_SENDMD5      0X0800          /*Send MD5 Authenticated packets */
+ #define SO_SENDMD5OPT   0X1000          /*Send optimized MD5 authenticated
+ 					  packets                        */
+ #define SO_SENDAHA      0X2000          /* Send AHA authenticated packets
+                                            on this socket */
+ #define SO_SENDNBOMD5OPT      0X3200    /* Network byte order md5 optimized*/
+ #define SO_SENDNULLCKSUM	0X4000
+ 
+ #define SO_SENDROG	0X4600 /* Rogaways algorithm */
+ #define SO_SENDNBOROG	0X4800 /* Network Byte Order Rogaways */
+ 
+ /* This is to store the logical bitwise OR of all the authorization 
+    options and is used by the layers by the layer above IP as a mask
+    to pass all the authentication options to ip_output
+ */
+ #define SO_AUTHOPTS   (SO_SENDAUTH | SO_SENDCKSUM | SO_SENDMD5 | SO_SENDMD5OPT | SO_SENDAHA | SO_SENDNBOMD5OPT | SO_SENDNULLCKSUM | SO_SENDROG | SO_SENDNBOROG)
+ 
+ 
+ #endif AH
+ 
  /*
   * N.B.: The following definition is present only for compatibility
   * with release 3.0.  It will disappear in later releases.
   */
+ 
  #define	SO_DONTLINGER	(~SO_LINGER)	/* ~SO_LINGER */
  
  /*
***************
*** 167,169 ****
--- 194,197 ----
  #define	MSG_MAXIOVLEN	16
  
  #endif /*!_sys_socket_h*/
+ 
